# Copyright MIT MRC 2013

__author__  = "Nathan Rittenhouse <nathan_@mit.edu>"
__author__  = "Neil Fitzgerald <neilfitz@mit.edu>"
__licence__ = "MIT"

from random import choice

def avoider_use_strategy_once(self, strategy, value, info):
	if info["initializing"]:
		pass
	else:
		self.avoid_strategies.append(strategy["name"])

def avoider_use_once_deterministic_only(self, strategy, value, info):
	if info["initializing"]:
		if strategy["non_deterministic"]:
			self.avoid_strategies.append(strategy["name"])
	else:
		self.avoid_strategies.append(strategy["name"])

def avoider_nondeterministic_only(self, strategy, value, info):
	if info["initializing"]:
		if not strategy["non_deterministic"]:
			self.avoid_strategies.append(strategy["name"])
	else:
		self.add_avoid_value(value)
                
# def range_strategy_selector(strategies, info):
def selector_range_breaker(self, strategies, info):
    return filter(lambda strategy: strategy["name"] == "violate_range", strategies)[0]

# def strategy_avoid_range_breaker(self, strategies):
def selector_random_avoid_range_breaker(self, strategies, info):
        while True:
                chosen = choice(strategies)
                if chosen['name'] != 'violate_range':
                        return chosen

# Class that wraps methods whose purpose is to determine if a strategy should not be used again.
class Avoider(object):
	def __init__(self, avoid_strategy, avoid_strategies, avoid_values=[]):
		self.avoid_strategy = avoid_strategy
		self.avoid_strategies = avoid_strategies
		self.avoid_values = avoid_values

	def add_avoid_value(self, value):
		if value == None:
			return
		
		self.avoid_values.append(value)

	def __call__(self, strategy, fuzz_value, info):
		return self.avoid_strategy(self, strategy, fuzz_value, info)

class Chooser(object):
	def __init__(self, choice_strategy):
		self.choice_strategy = choice_strategy

	def __call__(self, choices, info):
		return self.choice_strategy(self, choices, info)


